import java.awt.*;
import java.awt.event.*;

import javax.swing.*;

public class ShakerController extends JFrame {

	private ShakerPanel myShakerPanel;
	private JTextField myShiftField;
	private JButton myStartButton, myPauseButton;
	
	// continued from previous slide
			class StartButtonListener implements ActionListener {
				@Override
				public void actionPerformed(ActionEvent ae) {
					myShakerPanel.setRunning(true);
					myStartButton.setEnabled(false);
					myPauseButton.setEnabled(true);
				}
			}
			
			class PauseButtonListener implements ActionListener {
				@Override
				public void actionPerformed(ActionEvent ae) {
					myShakerPanel.setRunning(false);
					myStartButton.setEnabled(true);
					myPauseButton.setEnabled(false);
				}
			}

			class ShiftFieldListener implements ActionListener {
				@Override
				public void actionPerformed(ActionEvent ae) {
					try {
					     myShakerPanel.setShift(Integer.parseInt(myShiftField.getText()));
					} catch (Exception e) {
						myShiftField.setText("Invalid shift value. Please try again.");
					}			
				}
			}

	public ShakerController() {
		setTitle("Shaker");
		setDefaultCloseOperation(EXIT_ON_CLOSE);
		setLayout(new BorderLayout());

		myShakerPanel = new ShakerPanel();
		myShakerPanel.init();
		add(myShakerPanel, BorderLayout.NORTH);

		// a control panel
		JPanel controlPanel = new JPanel(new FlowLayout());
		myStartButton = new JButton("Start");
		myStartButton.setEnabled(false);
		myStartButton.addActionListener(new StartButtonListener());
		controlPanel.add(myStartButton);
		myPauseButton = new JButton("Pause");
		myPauseButton.setEnabled(true);
		myPauseButton.addActionListener(new PauseButtonListener());
		controlPanel.add(myPauseButton);
		controlPanel.add(new JLabel("Shift factor:"));
		myShiftField = new JTextField(3);
		myShiftField.setText(String.format("%d", myShakerPanel.getShift()));
		controlPanel.add(myShiftField);
		myShiftField.addActionListener(new ShiftFieldListener());
		add(controlPanel, BorderLayout.CENTER);
	}

		public static void main(String[] args) {
			ShakerController controller = new ShakerController();
			controller.setResizable(false);
			controller.pack();
			controller.setVisible(true);
		}
	} // closes ShakerController class declaration
		