import processing.core.PApplet;

/**
 * ShakerPanel1 is a simple Java encapsulation of a shaker animation from Processing. 
 * It draws a shaking circle and allows the user to reposition the circle using a mouse click.
 * 
 * @author kvlinden
 * @version Fall, 2009
 */
public class ShakerPanel extends PApplet {

	private static final int SIZE = 300;
	private int myX, myY, myShift;
	private boolean myRunningStatus;

	//constructor
	public ShakerPanel() {
		myX = myY = SIZE / 2;
		myShift = 10;
		myRunningStatus = true;
	}
	
	public void setup() {
		size(SIZE, SIZE);
		smooth();
		background(255);
	}

	public void draw() {
		if (myRunningStatus) {
			background(255);
			strokeWeight(2);
			ellipse(myX + random(-myShift / 2, myShift / 2), 
				myY + random(-myShift / 2, myShift / 2), 50, 50);
		}
	}

	public void mousePressed() {
		myX = mouseX;
		myY = mouseY;
	}
	
	public int getShift() {
		return myShift;
	}

	public void setShift(int shift) throws Exception {
		if (shift < 0) {
			throw new Exception("invalid shift value: " + shift);
		}
		myShift = shift;
	}

	public void setRunning(boolean status) {
		myRunningStatus = status;
	}
}